// **********************************************************************
//
// Copyright (c) 2003-2010 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.4.0

package Ice;

// <auto-generated>
//
// Generated from file `Stats.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>


/**
 * An interface Ice uses to report statistics, such as how much data
 * is sent or received. Applications must provide their own {@link Stats}
 * by implementing this interface and installing it in a communicator.
 * 
 **/
public interface _StatsOperationsNC
{
    /**
     * Callback to report that data has been sent.
     * 
     * @param protocol The protocol over which data has been sent (for
     * example "tcp", "udp", or "ssl").
     * 
     * @param num How many bytes have been sent.
     * 
     **/
    void bytesSent(String protocol, int num);

    /**
     * Callback to report that data has been received.
     * 
     * @param protocol The protocol over which data has been received
     * (for example "tcp", "udp", or "ssl").
     * 
     * @param num How many bytes have been received.
     * 
     **/
    void bytesReceived(String protocol, int num);
}
