// **********************************************************************
//
// Copyright (c) 2003-2010 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.4.0

package IceBox;

// <auto-generated>
//
// Generated from file `IceBox.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>


/**
 * Administers a set of {@link Service} instances.
 * 
 * @see Service
 * 
 **/
public interface ServiceManagerPrx extends Ice.ObjectPrx
{
    /**
     * Returns the checksums for the IceBox Slice definitions.
     * 
     * @return A dictionary mapping Slice type ids to their checksums.
     * 
     **/
    public java.util.Map<java.lang.String, java.lang.String> getSliceChecksums();

    /**
     * Returns the checksums for the IceBox Slice definitions.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return A dictionary mapping Slice type ids to their checksums.
     * 
     **/
    public java.util.Map<java.lang.String, java.lang.String> getSliceChecksums(java.util.Map<String, String> __ctx);

    /**
     * Returns the checksums for the IceBox Slice definitions.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getSliceChecksums();

    /**
     * Returns the checksums for the IceBox Slice definitions.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getSliceChecksums(java.util.Map<String, String> __ctx);

    /**
     * Returns the checksums for the IceBox Slice definitions.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getSliceChecksums(Ice.Callback __cb);

    /**
     * Returns the checksums for the IceBox Slice definitions.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getSliceChecksums(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns the checksums for the IceBox Slice definitions.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getSliceChecksums(Callback_ServiceManager_getSliceChecksums __cb);

    /**
     * Returns the checksums for the IceBox Slice definitions.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getSliceChecksums(java.util.Map<String, String> __ctx, Callback_ServiceManager_getSliceChecksums __cb);

    /**
     * Returns the checksums for the IceBox Slice definitions.
     * 
     * @param __result The asynchronous result object.
     * @return A dictionary mapping Slice type ids to their checksums.
     * 
     **/
    public java.util.Map<java.lang.String, java.lang.String> end_getSliceChecksums(Ice.AsyncResult __result);

    /**
     * Start an individual service.
     * 
     * @param service The service name.
     * 
     **/
    public void startService(String service)
        throws AlreadyStartedException,
               NoSuchServiceException;

    /**
     * Start an individual service.
     * 
     * @param service The service name.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public void startService(String service, java.util.Map<String, String> __ctx)
        throws AlreadyStartedException,
               NoSuchServiceException;

    /**
     * Start an individual service.
     * 
     * @param service The service name.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_startService(String service);

    /**
     * Start an individual service.
     * 
     * @param service The service name.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_startService(String service, java.util.Map<String, String> __ctx);

    /**
     * Start an individual service.
     * 
     * @param service The service name.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_startService(String service, Ice.Callback __cb);

    /**
     * Start an individual service.
     * 
     * @param service The service name.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_startService(String service, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Start an individual service.
     * 
     * @param service The service name.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_startService(String service, Callback_ServiceManager_startService __cb);

    /**
     * Start an individual service.
     * 
     * @param service The service name.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_startService(String service, java.util.Map<String, String> __ctx, Callback_ServiceManager_startService __cb);

    /**
     * Start an individual service.
     * 
     * @param __result The asynchronous result object.
     **/
    public void end_startService(Ice.AsyncResult __result)
        throws AlreadyStartedException,
               NoSuchServiceException;

    /**
     * Start an individual service.
     * 
     * @param __cb The callback object for the operation.
     * @param service The service name.
     * 
     **/
    public boolean startService_async(AMI_ServiceManager_startService __cb, String service);

    /**
     * Start an individual service.
     * 
     * @param __cb The callback object for the operation.
     * @param service The service name.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean startService_async(AMI_ServiceManager_startService __cb, String service, java.util.Map<String, String> __ctx);

    /**
     * Stop an individual service.
     * 
     * @param service The service name.
     * 
     **/
    public void stopService(String service)
        throws AlreadyStoppedException,
               NoSuchServiceException;

    /**
     * Stop an individual service.
     * 
     * @param service The service name.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public void stopService(String service, java.util.Map<String, String> __ctx)
        throws AlreadyStoppedException,
               NoSuchServiceException;

    /**
     * Stop an individual service.
     * 
     * @param service The service name.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_stopService(String service);

    /**
     * Stop an individual service.
     * 
     * @param service The service name.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_stopService(String service, java.util.Map<String, String> __ctx);

    /**
     * Stop an individual service.
     * 
     * @param service The service name.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_stopService(String service, Ice.Callback __cb);

    /**
     * Stop an individual service.
     * 
     * @param service The service name.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_stopService(String service, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Stop an individual service.
     * 
     * @param service The service name.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_stopService(String service, Callback_ServiceManager_stopService __cb);

    /**
     * Stop an individual service.
     * 
     * @param service The service name.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_stopService(String service, java.util.Map<String, String> __ctx, Callback_ServiceManager_stopService __cb);

    /**
     * Stop an individual service.
     * 
     * @param __result The asynchronous result object.
     **/
    public void end_stopService(Ice.AsyncResult __result)
        throws AlreadyStoppedException,
               NoSuchServiceException;

    /**
     * Stop an individual service.
     * 
     * @param __cb The callback object for the operation.
     * @param service The service name.
     * 
     **/
    public boolean stopService_async(AMI_ServiceManager_stopService __cb, String service);

    /**
     * Stop an individual service.
     * 
     * @param __cb The callback object for the operation.
     * @param service The service name.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean stopService_async(AMI_ServiceManager_stopService __cb, String service, java.util.Map<String, String> __ctx);

    /**
     * Registers a new observer with the ServiceManager.
     * 
     * @param observer The new observer
     * 
     **/
    public void addObserver(ServiceObserverPrx observer);

    /**
     * Registers a new observer with the ServiceManager.
     * 
     * @param observer The new observer
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public void addObserver(ServiceObserverPrx observer, java.util.Map<String, String> __ctx);

    /**
     * Registers a new observer with the ServiceManager.
     * 
     * @param observer The new observer
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addObserver(ServiceObserverPrx observer);

    /**
     * Registers a new observer with the ServiceManager.
     * 
     * @param observer The new observer
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addObserver(ServiceObserverPrx observer, java.util.Map<String, String> __ctx);

    /**
     * Registers a new observer with the ServiceManager.
     * 
     * @param observer The new observer
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addObserver(ServiceObserverPrx observer, Ice.Callback __cb);

    /**
     * Registers a new observer with the ServiceManager.
     * 
     * @param observer The new observer
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addObserver(ServiceObserverPrx observer, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Registers a new observer with the ServiceManager.
     * 
     * @param observer The new observer
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addObserver(ServiceObserverPrx observer, Callback_ServiceManager_addObserver __cb);

    /**
     * Registers a new observer with the ServiceManager.
     * 
     * @param observer The new observer
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addObserver(ServiceObserverPrx observer, java.util.Map<String, String> __ctx, Callback_ServiceManager_addObserver __cb);

    /**
     * Registers a new observer with the ServiceManager.
     * 
     * @param __result The asynchronous result object.
     **/
    public void end_addObserver(Ice.AsyncResult __result);

    /**
     * Registers a new observer with the ServiceManager.
     * 
     * @param __cb The callback object for the operation.
     * @param observer The new observer
     * 
     **/
    public boolean addObserver_async(AMI_ServiceManager_addObserver __cb, ServiceObserverPrx observer);

    /**
     * Registers a new observer with the ServiceManager.
     * 
     * @param __cb The callback object for the operation.
     * @param observer The new observer
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean addObserver_async(AMI_ServiceManager_addObserver __cb, ServiceObserverPrx observer, java.util.Map<String, String> __ctx);

    /**
     * Shut down all services. This causes {@link Service#stop} to be
     * invoked on all configured services.
     * 
     **/
    public void shutdown();

    /**
     * Shut down all services. This causes {@link Service#stop} to be
     * invoked on all configured services.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public void shutdown(java.util.Map<String, String> __ctx);

    /**
     * Shut down all services. This causes {@link Service#stop} to be
     * invoked on all configured services.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_shutdown();

    /**
     * Shut down all services. This causes {@link Service#stop} to be
     * invoked on all configured services.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_shutdown(java.util.Map<String, String> __ctx);

    /**
     * Shut down all services. This causes {@link Service#stop} to be
     * invoked on all configured services.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_shutdown(Ice.Callback __cb);

    /**
     * Shut down all services. This causes {@link Service#stop} to be
     * invoked on all configured services.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_shutdown(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Shut down all services. This causes {@link Service#stop} to be
     * invoked on all configured services.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_shutdown(Callback_ServiceManager_shutdown __cb);

    /**
     * Shut down all services. This causes {@link Service#stop} to be
     * invoked on all configured services.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_shutdown(java.util.Map<String, String> __ctx, Callback_ServiceManager_shutdown __cb);

    /**
     * Shut down all services. This causes {@link Service#stop} to be
     * invoked on all configured services.
     * 
     * @param __result The asynchronous result object.
     **/
    public void end_shutdown(Ice.AsyncResult __result);
}
