// **********************************************************************
//
// Copyright (c) 2003-2010 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.4.0

package IceGrid;

// <auto-generated>
//
// Generated from file `Locator.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>


/**
 * The IceGrid locator interface provides access to the {@link Query}
 * and {@link Registry} object of the IceGrid registry.
 * 
 * @see Query
 * @see Registry
 * 
 **/
public final class LocatorPrxHelper extends Ice.ObjectPrxHelperBase implements LocatorPrx
{
    /**
     * Find an adapter by id and return its proxy (a dummy direct
     * proxy created by the adapter).
     * 
     * @param id The adapter id.
     * 
     * @return The adapter proxy, or null if the adapter is not active.
     * 
     * @throws AdapterNotFoundException Raised if the adapter cannot be
     * found.
     * 
     **/
    public Ice.ObjectPrx
    findAdapterById(String id)
        throws Ice.AdapterNotFoundException
    {
        return findAdapterById(id, null, false);
    }

    /**
     * Find an adapter by id and return its proxy (a dummy direct
     * proxy created by the adapter).
     * 
     * @param id The adapter id.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The adapter proxy, or null if the adapter is not active.
     * 
     * @throws AdapterNotFoundException Raised if the adapter cannot be
     * found.
     * 
     **/
    public Ice.ObjectPrx
    findAdapterById(String id, java.util.Map<String, String> __ctx)
        throws Ice.AdapterNotFoundException
    {
        return findAdapterById(id, __ctx, true);
    }

    private Ice.ObjectPrx
    findAdapterById(String id, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws Ice.AdapterNotFoundException
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        int __cnt = 0;
        while(true)
        {
            Ice._ObjectDel __delBase = null;
            try
            {
                __checkTwowayOnly("findAdapterById");
                __delBase = __getDelegate(false);
                _LocatorDel __del = (_LocatorDel)__delBase;
                return __del.findAdapterById(id, __ctx);
            }
            catch(IceInternal.LocalExceptionWrapper __ex)
            {
                __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt);
            }
            catch(Ice.LocalException __ex)
            {
                __cnt = __handleException(__delBase, __ex, null, __cnt);
            }
        }
    }

    private static final String __findAdapterById_name = "findAdapterById";

    /**
     * Find an adapter by id and return its proxy (a dummy direct
     * proxy created by the adapter).
     * 
     * @param __cb The callback object for the operation.
     * @param id The adapter id.
     * 
     **/
    public Ice.AsyncResult begin_findAdapterById(String id)
    {
        return begin_findAdapterById(id, null, false, null);
    }

    /**
     * Find an adapter by id and return its proxy (a dummy direct
     * proxy created by the adapter).
     * 
     * @param __cb The callback object for the operation.
     * @param id The adapter id.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findAdapterById(String id, java.util.Map<String, String> __ctx)
    {
        return begin_findAdapterById(id, __ctx, true, null);
    }

    /**
     * Find an adapter by id and return its proxy (a dummy direct
     * proxy created by the adapter).
     * 
     * @param __cb The callback object for the operation.
     * @param id The adapter id.
     * 
     **/
    public Ice.AsyncResult begin_findAdapterById(String id, Ice.Callback __cb)
    {
        return begin_findAdapterById(id, null, false, __cb);
    }

    /**
     * Find an adapter by id and return its proxy (a dummy direct
     * proxy created by the adapter).
     * 
     * @param __cb The callback object for the operation.
     * @param id The adapter id.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findAdapterById(String id, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_findAdapterById(id, __ctx, true, __cb);
    }

    /**
     * Find an adapter by id and return its proxy (a dummy direct
     * proxy created by the adapter).
     * 
     * @param __cb The callback object for the operation.
     * @param id The adapter id.
     * 
     **/
    public Ice.AsyncResult begin_findAdapterById(String id, Ice.Callback_Locator_findAdapterById __cb)
    {
        return begin_findAdapterById(id, null, false, __cb);
    }

    /**
     * Find an adapter by id and return its proxy (a dummy direct
     * proxy created by the adapter).
     * 
     * @param __cb The callback object for the operation.
     * @param id The adapter id.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findAdapterById(String id, java.util.Map<String, String> __ctx, Ice.Callback_Locator_findAdapterById __cb)
    {
        return begin_findAdapterById(id, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_findAdapterById(String id, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__findAdapterById_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __findAdapterById_name, __cb);
        try
        {
            __result.__prepare(__findAdapterById_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__os();
            __os.writeString(id);
            __os.endWriteEncaps();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) The adapter proxy, or null if the adapter is not active.
     * 
     **/
    public Ice.ObjectPrx end_findAdapterById(Ice.AsyncResult __result)
        throws Ice.AdapterNotFoundException
    {
        Ice.AsyncResult.__check(__result, this, __findAdapterById_name);
        if(!__result.__wait())
        {
            try
            {
                __result.__throwUserException();
            }
            catch(Ice.AdapterNotFoundException __ex)
            {
                throw __ex;
            }
            catch(Ice.UserException __ex)
            {
                throw new Ice.UnknownUserException(__ex.ice_name());
            }
        }
        Ice.ObjectPrx __ret;
        IceInternal.BasicStream __is = __result.__is();
        __is.startReadEncaps();
        __ret = __is.readProxy();
        __is.endReadEncaps();
        return __ret;
    }

    /**
     * Find an adapter by id and return its proxy (a dummy direct
     * proxy created by the adapter).
     * 
     * @param __cb The callback object for the operation.
     * @param id The adapter id.
     * 
     **/
    public boolean
    findAdapterById_async(Ice.AMI_Locator_findAdapterById __cb, String id)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__findAdapterById_name);
            __r = begin_findAdapterById(id, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __findAdapterById_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Find an adapter by id and return its proxy (a dummy direct
     * proxy created by the adapter).
     * 
     * @param __cb The callback object for the operation.
     * @param id The adapter id.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean
    findAdapterById_async(Ice.AMI_Locator_findAdapterById __cb, String id, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__findAdapterById_name);
            __r = begin_findAdapterById(id, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __findAdapterById_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Find an object by identity and return its proxy.
     * 
     * @param id The identity.
     * 
     * @return The proxy, or null if the object is not active.
     * 
     * @throws ObjectNotFoundException Raised if the object cannot
     * be found.
     * 
     **/
    public Ice.ObjectPrx
    findObjectById(Ice.Identity id)
        throws Ice.ObjectNotFoundException
    {
        return findObjectById(id, null, false);
    }

    /**
     * Find an object by identity and return its proxy.
     * 
     * @param id The identity.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The proxy, or null if the object is not active.
     * 
     * @throws ObjectNotFoundException Raised if the object cannot
     * be found.
     * 
     **/
    public Ice.ObjectPrx
    findObjectById(Ice.Identity id, java.util.Map<String, String> __ctx)
        throws Ice.ObjectNotFoundException
    {
        return findObjectById(id, __ctx, true);
    }

    private Ice.ObjectPrx
    findObjectById(Ice.Identity id, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws Ice.ObjectNotFoundException
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        int __cnt = 0;
        while(true)
        {
            Ice._ObjectDel __delBase = null;
            try
            {
                __checkTwowayOnly("findObjectById");
                __delBase = __getDelegate(false);
                _LocatorDel __del = (_LocatorDel)__delBase;
                return __del.findObjectById(id, __ctx);
            }
            catch(IceInternal.LocalExceptionWrapper __ex)
            {
                __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt);
            }
            catch(Ice.LocalException __ex)
            {
                __cnt = __handleException(__delBase, __ex, null, __cnt);
            }
        }
    }

    private static final String __findObjectById_name = "findObjectById";

    /**
     * Find an object by identity and return its proxy.
     * 
     * @param __cb The callback object for the operation.
     * @param id The identity.
     * 
     **/
    public Ice.AsyncResult begin_findObjectById(Ice.Identity id)
    {
        return begin_findObjectById(id, null, false, null);
    }

    /**
     * Find an object by identity and return its proxy.
     * 
     * @param __cb The callback object for the operation.
     * @param id The identity.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findObjectById(Ice.Identity id, java.util.Map<String, String> __ctx)
    {
        return begin_findObjectById(id, __ctx, true, null);
    }

    /**
     * Find an object by identity and return its proxy.
     * 
     * @param __cb The callback object for the operation.
     * @param id The identity.
     * 
     **/
    public Ice.AsyncResult begin_findObjectById(Ice.Identity id, Ice.Callback __cb)
    {
        return begin_findObjectById(id, null, false, __cb);
    }

    /**
     * Find an object by identity and return its proxy.
     * 
     * @param __cb The callback object for the operation.
     * @param id The identity.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findObjectById(Ice.Identity id, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_findObjectById(id, __ctx, true, __cb);
    }

    /**
     * Find an object by identity and return its proxy.
     * 
     * @param __cb The callback object for the operation.
     * @param id The identity.
     * 
     **/
    public Ice.AsyncResult begin_findObjectById(Ice.Identity id, Ice.Callback_Locator_findObjectById __cb)
    {
        return begin_findObjectById(id, null, false, __cb);
    }

    /**
     * Find an object by identity and return its proxy.
     * 
     * @param __cb The callback object for the operation.
     * @param id The identity.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findObjectById(Ice.Identity id, java.util.Map<String, String> __ctx, Ice.Callback_Locator_findObjectById __cb)
    {
        return begin_findObjectById(id, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_findObjectById(Ice.Identity id, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__findObjectById_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __findObjectById_name, __cb);
        try
        {
            __result.__prepare(__findObjectById_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__os();
            id.__write(__os);
            __os.endWriteEncaps();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) The proxy, or null if the object is not active.
     * 
     **/
    public Ice.ObjectPrx end_findObjectById(Ice.AsyncResult __result)
        throws Ice.ObjectNotFoundException
    {
        Ice.AsyncResult.__check(__result, this, __findObjectById_name);
        if(!__result.__wait())
        {
            try
            {
                __result.__throwUserException();
            }
            catch(Ice.ObjectNotFoundException __ex)
            {
                throw __ex;
            }
            catch(Ice.UserException __ex)
            {
                throw new Ice.UnknownUserException(__ex.ice_name());
            }
        }
        Ice.ObjectPrx __ret;
        IceInternal.BasicStream __is = __result.__is();
        __is.startReadEncaps();
        __ret = __is.readProxy();
        __is.endReadEncaps();
        return __ret;
    }

    /**
     * Find an object by identity and return its proxy.
     * 
     * @param __cb The callback object for the operation.
     * @param id The identity.
     * 
     **/
    public boolean
    findObjectById_async(Ice.AMI_Locator_findObjectById __cb, Ice.Identity id)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__findObjectById_name);
            __r = begin_findObjectById(id, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __findObjectById_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Find an object by identity and return its proxy.
     * 
     * @param __cb The callback object for the operation.
     * @param id The identity.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean
    findObjectById_async(Ice.AMI_Locator_findObjectById __cb, Ice.Identity id, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__findObjectById_name);
            __r = begin_findObjectById(id, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __findObjectById_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Get the locator registry.
     * 
     * @return The locator registry.
     * 
     **/
    public Ice.LocatorRegistryPrx
    getRegistry()
    {
        return getRegistry(null, false);
    }

    /**
     * Get the locator registry.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The locator registry.
     * 
     **/
    public Ice.LocatorRegistryPrx
    getRegistry(java.util.Map<String, String> __ctx)
    {
        return getRegistry(__ctx, true);
    }

    private Ice.LocatorRegistryPrx
    getRegistry(java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        int __cnt = 0;
        while(true)
        {
            Ice._ObjectDel __delBase = null;
            try
            {
                __checkTwowayOnly("getRegistry");
                __delBase = __getDelegate(false);
                _LocatorDel __del = (_LocatorDel)__delBase;
                return __del.getRegistry(__ctx);
            }
            catch(IceInternal.LocalExceptionWrapper __ex)
            {
                __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt);
            }
            catch(Ice.LocalException __ex)
            {
                __cnt = __handleException(__delBase, __ex, null, __cnt);
            }
        }
    }

    private static final String __getRegistry_name = "getRegistry";

    /**
     * Get the locator registry.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getRegistry()
    {
        return begin_getRegistry(null, false, null);
    }

    /**
     * Get the locator registry.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getRegistry(java.util.Map<String, String> __ctx)
    {
        return begin_getRegistry(__ctx, true, null);
    }

    /**
     * Get the locator registry.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getRegistry(Ice.Callback __cb)
    {
        return begin_getRegistry(null, false, __cb);
    }

    /**
     * Get the locator registry.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getRegistry(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getRegistry(__ctx, true, __cb);
    }

    /**
     * Get the locator registry.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getRegistry(Ice.Callback_Locator_getRegistry __cb)
    {
        return begin_getRegistry(null, false, __cb);
    }

    /**
     * Get the locator registry.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getRegistry(java.util.Map<String, String> __ctx, Ice.Callback_Locator_getRegistry __cb)
    {
        return begin_getRegistry(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getRegistry(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getRegistry_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getRegistry_name, __cb);
        try
        {
            __result.__prepare(__getRegistry_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__os();
            __os.endWriteEncaps();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) The locator registry.
     * 
     **/
    public Ice.LocatorRegistryPrx end_getRegistry(Ice.AsyncResult __result)
    {
        Ice.AsyncResult.__check(__result, this, __getRegistry_name);
        if(!__result.__wait())
        {
            try
            {
                __result.__throwUserException();
            }
            catch(Ice.UserException __ex)
            {
                throw new Ice.UnknownUserException(__ex.ice_name());
            }
        }
        Ice.LocatorRegistryPrx __ret;
        IceInternal.BasicStream __is = __result.__is();
        __is.startReadEncaps();
        __ret = Ice.LocatorRegistryPrxHelper.__read(__is);
        __is.endReadEncaps();
        return __ret;
    }

    /**
     * Get the proxy of the query object hosted by this IceGrid
     * registry.
     * 
     * @return The proxy of the query object.
     * 
     **/
    public QueryPrx
    getLocalQuery()
    {
        return getLocalQuery(null, false);
    }

    /**
     * Get the proxy of the query object hosted by this IceGrid
     * registry.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The proxy of the query object.
     * 
     **/
    public QueryPrx
    getLocalQuery(java.util.Map<String, String> __ctx)
    {
        return getLocalQuery(__ctx, true);
    }

    private QueryPrx
    getLocalQuery(java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        int __cnt = 0;
        while(true)
        {
            Ice._ObjectDel __delBase = null;
            try
            {
                __checkTwowayOnly("getLocalQuery");
                __delBase = __getDelegate(false);
                _LocatorDel __del = (_LocatorDel)__delBase;
                return __del.getLocalQuery(__ctx);
            }
            catch(IceInternal.LocalExceptionWrapper __ex)
            {
                __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt);
            }
            catch(Ice.LocalException __ex)
            {
                __cnt = __handleException(__delBase, __ex, null, __cnt);
            }
        }
    }

    private static final String __getLocalQuery_name = "getLocalQuery";

    /**
     * Get the proxy of the query object hosted by this IceGrid
     * registry.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getLocalQuery()
    {
        return begin_getLocalQuery(null, false, null);
    }

    /**
     * Get the proxy of the query object hosted by this IceGrid
     * registry.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getLocalQuery(java.util.Map<String, String> __ctx)
    {
        return begin_getLocalQuery(__ctx, true, null);
    }

    /**
     * Get the proxy of the query object hosted by this IceGrid
     * registry.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getLocalQuery(Ice.Callback __cb)
    {
        return begin_getLocalQuery(null, false, __cb);
    }

    /**
     * Get the proxy of the query object hosted by this IceGrid
     * registry.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getLocalQuery(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getLocalQuery(__ctx, true, __cb);
    }

    /**
     * Get the proxy of the query object hosted by this IceGrid
     * registry.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getLocalQuery(Callback_Locator_getLocalQuery __cb)
    {
        return begin_getLocalQuery(null, false, __cb);
    }

    /**
     * Get the proxy of the query object hosted by this IceGrid
     * registry.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getLocalQuery(java.util.Map<String, String> __ctx, Callback_Locator_getLocalQuery __cb)
    {
        return begin_getLocalQuery(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getLocalQuery(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getLocalQuery_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getLocalQuery_name, __cb);
        try
        {
            __result.__prepare(__getLocalQuery_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__os();
            __os.endWriteEncaps();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) The proxy of the query object.
     * 
     **/
    public QueryPrx end_getLocalQuery(Ice.AsyncResult __result)
    {
        Ice.AsyncResult.__check(__result, this, __getLocalQuery_name);
        if(!__result.__wait())
        {
            try
            {
                __result.__throwUserException();
            }
            catch(Ice.UserException __ex)
            {
                throw new Ice.UnknownUserException(__ex.ice_name());
            }
        }
        QueryPrx __ret;
        IceInternal.BasicStream __is = __result.__is();
        __is.startReadEncaps();
        __ret = QueryPrxHelper.__read(__is);
        __is.endReadEncaps();
        return __ret;
    }

    /**
     * Get the proxy of the registry object hosted by this IceGrid
     * registry.
     * 
     * @return The proxy of the registry object.
     * 
     **/
    public RegistryPrx
    getLocalRegistry()
    {
        return getLocalRegistry(null, false);
    }

    /**
     * Get the proxy of the registry object hosted by this IceGrid
     * registry.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The proxy of the registry object.
     * 
     **/
    public RegistryPrx
    getLocalRegistry(java.util.Map<String, String> __ctx)
    {
        return getLocalRegistry(__ctx, true);
    }

    private RegistryPrx
    getLocalRegistry(java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        int __cnt = 0;
        while(true)
        {
            Ice._ObjectDel __delBase = null;
            try
            {
                __checkTwowayOnly("getLocalRegistry");
                __delBase = __getDelegate(false);
                _LocatorDel __del = (_LocatorDel)__delBase;
                return __del.getLocalRegistry(__ctx);
            }
            catch(IceInternal.LocalExceptionWrapper __ex)
            {
                __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt);
            }
            catch(Ice.LocalException __ex)
            {
                __cnt = __handleException(__delBase, __ex, null, __cnt);
            }
        }
    }

    private static final String __getLocalRegistry_name = "getLocalRegistry";

    /**
     * Get the proxy of the registry object hosted by this IceGrid
     * registry.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getLocalRegistry()
    {
        return begin_getLocalRegistry(null, false, null);
    }

    /**
     * Get the proxy of the registry object hosted by this IceGrid
     * registry.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getLocalRegistry(java.util.Map<String, String> __ctx)
    {
        return begin_getLocalRegistry(__ctx, true, null);
    }

    /**
     * Get the proxy of the registry object hosted by this IceGrid
     * registry.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getLocalRegistry(Ice.Callback __cb)
    {
        return begin_getLocalRegistry(null, false, __cb);
    }

    /**
     * Get the proxy of the registry object hosted by this IceGrid
     * registry.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getLocalRegistry(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getLocalRegistry(__ctx, true, __cb);
    }

    /**
     * Get the proxy of the registry object hosted by this IceGrid
     * registry.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getLocalRegistry(Callback_Locator_getLocalRegistry __cb)
    {
        return begin_getLocalRegistry(null, false, __cb);
    }

    /**
     * Get the proxy of the registry object hosted by this IceGrid
     * registry.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getLocalRegistry(java.util.Map<String, String> __ctx, Callback_Locator_getLocalRegistry __cb)
    {
        return begin_getLocalRegistry(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getLocalRegistry(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getLocalRegistry_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getLocalRegistry_name, __cb);
        try
        {
            __result.__prepare(__getLocalRegistry_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__os();
            __os.endWriteEncaps();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) The proxy of the registry object.
     * 
     **/
    public RegistryPrx end_getLocalRegistry(Ice.AsyncResult __result)
    {
        Ice.AsyncResult.__check(__result, this, __getLocalRegistry_name);
        if(!__result.__wait())
        {
            try
            {
                __result.__throwUserException();
            }
            catch(Ice.UserException __ex)
            {
                throw new Ice.UnknownUserException(__ex.ice_name());
            }
        }
        RegistryPrx __ret;
        IceInternal.BasicStream __is = __result.__is();
        __is.startReadEncaps();
        __ret = RegistryPrxHelper.__read(__is);
        __is.endReadEncaps();
        return __ret;
    }

    public static LocatorPrx
    checkedCast(Ice.ObjectPrx __obj)
    {
        LocatorPrx __d = null;
        if(__obj != null)
        {
            try
            {
                __d = (LocatorPrx)__obj;
            }
            catch(ClassCastException ex)
            {
                if(__obj.ice_isA("::IceGrid::Locator"))
                {
                    LocatorPrxHelper __h = new LocatorPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static LocatorPrx
    checkedCast(Ice.ObjectPrx __obj, java.util.Map<String, String> __ctx)
    {
        LocatorPrx __d = null;
        if(__obj != null)
        {
            try
            {
                __d = (LocatorPrx)__obj;
            }
            catch(ClassCastException ex)
            {
                if(__obj.ice_isA("::IceGrid::Locator", __ctx))
                {
                    LocatorPrxHelper __h = new LocatorPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static LocatorPrx
    checkedCast(Ice.ObjectPrx __obj, String __facet)
    {
        LocatorPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA("::IceGrid::Locator"))
                {
                    LocatorPrxHelper __h = new LocatorPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static LocatorPrx
    checkedCast(Ice.ObjectPrx __obj, String __facet, java.util.Map<String, String> __ctx)
    {
        LocatorPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA("::IceGrid::Locator", __ctx))
                {
                    LocatorPrxHelper __h = new LocatorPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static LocatorPrx
    uncheckedCast(Ice.ObjectPrx __obj)
    {
        LocatorPrx __d = null;
        if(__obj != null)
        {
            try
            {
                __d = (LocatorPrx)__obj;
            }
            catch(ClassCastException ex)
            {
                LocatorPrxHelper __h = new LocatorPrxHelper();
                __h.__copyFrom(__obj);
                __d = __h;
            }
        }
        return __d;
    }

    public static LocatorPrx
    uncheckedCast(Ice.ObjectPrx __obj, String __facet)
    {
        LocatorPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            LocatorPrxHelper __h = new LocatorPrxHelper();
            __h.__copyFrom(__bb);
            __d = __h;
        }
        return __d;
    }

    protected Ice._ObjectDelM
    __createDelegateM()
    {
        return new _LocatorDelM();
    }

    protected Ice._ObjectDelD
    __createDelegateD()
    {
        return new _LocatorDelD();
    }

    public static void
    __write(IceInternal.BasicStream __os, LocatorPrx v)
    {
        __os.writeProxy(v);
    }

    public static LocatorPrx
    __read(IceInternal.BasicStream __is)
    {
        Ice.ObjectPrx proxy = __is.readProxy();
        if(proxy != null)
        {
            LocatorPrxHelper result = new LocatorPrxHelper();
            result.__copyFrom(proxy);
            return result;
        }
        return null;
    }
}
