// **********************************************************************
//
// Copyright (c) 2003-2010 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.4.0

package IceGrid;

// <auto-generated>
//
// Generated from file `Observer.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>


/**
 * The node observer interface. Observers should implement this
 * interface to receive information about the state of the IceGrid
 * nodes.
 * 
 **/
public final class NodeObserverPrxHelper extends Ice.ObjectPrxHelperBase implements NodeObserverPrx
{
    /**
     * The <tt>nodeDown</tt> operation is called to notify an observer that a node
     * went down.
     * 
     * @param name The node name.
     * 
     **/
    public void
    nodeDown(String name)
    {
        nodeDown(name, null, false);
    }

    /**
     * The <tt>nodeDown</tt> operation is called to notify an observer that a node
     * went down.
     * 
     * @param name The node name.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public void
    nodeDown(String name, java.util.Map<String, String> __ctx)
    {
        nodeDown(name, __ctx, true);
    }

    private void
    nodeDown(String name, java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        int __cnt = 0;
        while(true)
        {
            Ice._ObjectDel __delBase = null;
            try
            {
                __delBase = __getDelegate(false);
                _NodeObserverDel __del = (_NodeObserverDel)__delBase;
                __del.nodeDown(name, __ctx);
                return;
            }
            catch(IceInternal.LocalExceptionWrapper __ex)
            {
                __handleExceptionWrapper(__delBase, __ex);
            }
            catch(Ice.LocalException __ex)
            {
                __cnt = __handleException(__delBase, __ex, null, __cnt);
            }
        }
    }

    private static final String __nodeDown_name = "nodeDown";

    /**
     * The <tt>nodeDown</tt> operation is called to notify an observer that a node
     * went down.
     * 
     * @param __cb The callback object for the operation.
     * @param name The node name.
     * 
     **/
    public Ice.AsyncResult begin_nodeDown(String name)
    {
        return begin_nodeDown(name, null, false, null);
    }

    /**
     * The <tt>nodeDown</tt> operation is called to notify an observer that a node
     * went down.
     * 
     * @param __cb The callback object for the operation.
     * @param name The node name.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_nodeDown(String name, java.util.Map<String, String> __ctx)
    {
        return begin_nodeDown(name, __ctx, true, null);
    }

    /**
     * The <tt>nodeDown</tt> operation is called to notify an observer that a node
     * went down.
     * 
     * @param __cb The callback object for the operation.
     * @param name The node name.
     * 
     **/
    public Ice.AsyncResult begin_nodeDown(String name, Ice.Callback __cb)
    {
        return begin_nodeDown(name, null, false, __cb);
    }

    /**
     * The <tt>nodeDown</tt> operation is called to notify an observer that a node
     * went down.
     * 
     * @param __cb The callback object for the operation.
     * @param name The node name.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_nodeDown(String name, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_nodeDown(name, __ctx, true, __cb);
    }

    /**
     * The <tt>nodeDown</tt> operation is called to notify an observer that a node
     * went down.
     * 
     * @param __cb The callback object for the operation.
     * @param name The node name.
     * 
     **/
    public Ice.AsyncResult begin_nodeDown(String name, Callback_NodeObserver_nodeDown __cb)
    {
        return begin_nodeDown(name, null, false, __cb);
    }

    /**
     * The <tt>nodeDown</tt> operation is called to notify an observer that a node
     * went down.
     * 
     * @param __cb The callback object for the operation.
     * @param name The node name.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_nodeDown(String name, java.util.Map<String, String> __ctx, Callback_NodeObserver_nodeDown __cb)
    {
        return begin_nodeDown(name, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_nodeDown(String name, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __nodeDown_name, __cb);
        try
        {
            __result.__prepare(__nodeDown_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__os();
            __os.writeString(name);
            __os.endWriteEncaps();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_nodeDown(Ice.AsyncResult __result)
    {
        __end(__result, __nodeDown_name);
    }

    /**
     * The <tt>nodeDown</tt> operation is called to notify an observer that a node
     * went down.
     * 
     * @param __cb The callback object for the operation.
     * @param name The node name.
     * 
     **/
    public boolean
    nodeDown_async(AMI_NodeObserver_nodeDown __cb, String name)
    {
        Ice.AsyncResult __r = begin_nodeDown(name, null, false, __cb);
        return __r.sentSynchronously();
    }

    /**
     * The <tt>nodeDown</tt> operation is called to notify an observer that a node
     * went down.
     * 
     * @param __cb The callback object for the operation.
     * @param name The node name.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean
    nodeDown_async(AMI_NodeObserver_nodeDown __cb, String name, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r = begin_nodeDown(name, __ctx, true, __cb);
        return __r.sentSynchronously();
    }

    /**
     * The <tt>nodeInit</tt> operation indicates the current state
     * of nodes. It is called after the registration of an observer.
     * 
     * @param nodes The current state of the nodes.
     * 
     **/
    public void
    nodeInit(NodeDynamicInfo[] nodes)
    {
        nodeInit(nodes, null, false);
    }

    /**
     * The <tt>nodeInit</tt> operation indicates the current state
     * of nodes. It is called after the registration of an observer.
     * 
     * @param nodes The current state of the nodes.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public void
    nodeInit(NodeDynamicInfo[] nodes, java.util.Map<String, String> __ctx)
    {
        nodeInit(nodes, __ctx, true);
    }

    private void
    nodeInit(NodeDynamicInfo[] nodes, java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        int __cnt = 0;
        while(true)
        {
            Ice._ObjectDel __delBase = null;
            try
            {
                __delBase = __getDelegate(false);
                _NodeObserverDel __del = (_NodeObserverDel)__delBase;
                __del.nodeInit(nodes, __ctx);
                return;
            }
            catch(IceInternal.LocalExceptionWrapper __ex)
            {
                __handleExceptionWrapper(__delBase, __ex);
            }
            catch(Ice.LocalException __ex)
            {
                __cnt = __handleException(__delBase, __ex, null, __cnt);
            }
        }
    }

    private static final String __nodeInit_name = "nodeInit";

    /**
     * The <tt>nodeInit</tt> operation indicates the current state
     * of nodes. It is called after the registration of an observer.
     * 
     * @param __cb The callback object for the operation.
     * @param nodes The current state of the nodes.
     * 
     **/
    public Ice.AsyncResult begin_nodeInit(NodeDynamicInfo[] nodes)
    {
        return begin_nodeInit(nodes, null, false, null);
    }

    /**
     * The <tt>nodeInit</tt> operation indicates the current state
     * of nodes. It is called after the registration of an observer.
     * 
     * @param __cb The callback object for the operation.
     * @param nodes The current state of the nodes.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_nodeInit(NodeDynamicInfo[] nodes, java.util.Map<String, String> __ctx)
    {
        return begin_nodeInit(nodes, __ctx, true, null);
    }

    /**
     * The <tt>nodeInit</tt> operation indicates the current state
     * of nodes. It is called after the registration of an observer.
     * 
     * @param __cb The callback object for the operation.
     * @param nodes The current state of the nodes.
     * 
     **/
    public Ice.AsyncResult begin_nodeInit(NodeDynamicInfo[] nodes, Ice.Callback __cb)
    {
        return begin_nodeInit(nodes, null, false, __cb);
    }

    /**
     * The <tt>nodeInit</tt> operation indicates the current state
     * of nodes. It is called after the registration of an observer.
     * 
     * @param __cb The callback object for the operation.
     * @param nodes The current state of the nodes.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_nodeInit(NodeDynamicInfo[] nodes, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_nodeInit(nodes, __ctx, true, __cb);
    }

    /**
     * The <tt>nodeInit</tt> operation indicates the current state
     * of nodes. It is called after the registration of an observer.
     * 
     * @param __cb The callback object for the operation.
     * @param nodes The current state of the nodes.
     * 
     **/
    public Ice.AsyncResult begin_nodeInit(NodeDynamicInfo[] nodes, Callback_NodeObserver_nodeInit __cb)
    {
        return begin_nodeInit(nodes, null, false, __cb);
    }

    /**
     * The <tt>nodeInit</tt> operation indicates the current state
     * of nodes. It is called after the registration of an observer.
     * 
     * @param __cb The callback object for the operation.
     * @param nodes The current state of the nodes.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_nodeInit(NodeDynamicInfo[] nodes, java.util.Map<String, String> __ctx, Callback_NodeObserver_nodeInit __cb)
    {
        return begin_nodeInit(nodes, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_nodeInit(NodeDynamicInfo[] nodes, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __nodeInit_name, __cb);
        try
        {
            __result.__prepare(__nodeInit_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__os();
            NodeDynamicInfoSeqHelper.write(__os, nodes);
            __os.endWriteEncaps();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_nodeInit(Ice.AsyncResult __result)
    {
        __end(__result, __nodeInit_name);
    }

    /**
     * The <tt>nodeInit</tt> operation indicates the current state
     * of nodes. It is called after the registration of an observer.
     * 
     * @param __cb The callback object for the operation.
     * @param nodes The current state of the nodes.
     * 
     **/
    public boolean
    nodeInit_async(AMI_NodeObserver_nodeInit __cb, NodeDynamicInfo[] nodes)
    {
        Ice.AsyncResult __r = begin_nodeInit(nodes, null, false, __cb);
        return __r.sentSynchronously();
    }

    /**
     * The <tt>nodeInit</tt> operation indicates the current state
     * of nodes. It is called after the registration of an observer.
     * 
     * @param __cb The callback object for the operation.
     * @param nodes The current state of the nodes.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean
    nodeInit_async(AMI_NodeObserver_nodeInit __cb, NodeDynamicInfo[] nodes, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r = begin_nodeInit(nodes, __ctx, true, __cb);
        return __r.sentSynchronously();
    }

    /**
     * The <tt>nodeUp</tt> operation is called to notify an observer that a node
     * came up.
     * 
     * @param node The node state.
     * 
     **/
    public void
    nodeUp(NodeDynamicInfo node)
    {
        nodeUp(node, null, false);
    }

    /**
     * The <tt>nodeUp</tt> operation is called to notify an observer that a node
     * came up.
     * 
     * @param node The node state.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public void
    nodeUp(NodeDynamicInfo node, java.util.Map<String, String> __ctx)
    {
        nodeUp(node, __ctx, true);
    }

    private void
    nodeUp(NodeDynamicInfo node, java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        int __cnt = 0;
        while(true)
        {
            Ice._ObjectDel __delBase = null;
            try
            {
                __delBase = __getDelegate(false);
                _NodeObserverDel __del = (_NodeObserverDel)__delBase;
                __del.nodeUp(node, __ctx);
                return;
            }
            catch(IceInternal.LocalExceptionWrapper __ex)
            {
                __handleExceptionWrapper(__delBase, __ex);
            }
            catch(Ice.LocalException __ex)
            {
                __cnt = __handleException(__delBase, __ex, null, __cnt);
            }
        }
    }

    private static final String __nodeUp_name = "nodeUp";

    /**
     * The <tt>nodeUp</tt> operation is called to notify an observer that a node
     * came up.
     * 
     * @param __cb The callback object for the operation.
     * @param node The node state.
     * 
     **/
    public Ice.AsyncResult begin_nodeUp(NodeDynamicInfo node)
    {
        return begin_nodeUp(node, null, false, null);
    }

    /**
     * The <tt>nodeUp</tt> operation is called to notify an observer that a node
     * came up.
     * 
     * @param __cb The callback object for the operation.
     * @param node The node state.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_nodeUp(NodeDynamicInfo node, java.util.Map<String, String> __ctx)
    {
        return begin_nodeUp(node, __ctx, true, null);
    }

    /**
     * The <tt>nodeUp</tt> operation is called to notify an observer that a node
     * came up.
     * 
     * @param __cb The callback object for the operation.
     * @param node The node state.
     * 
     **/
    public Ice.AsyncResult begin_nodeUp(NodeDynamicInfo node, Ice.Callback __cb)
    {
        return begin_nodeUp(node, null, false, __cb);
    }

    /**
     * The <tt>nodeUp</tt> operation is called to notify an observer that a node
     * came up.
     * 
     * @param __cb The callback object for the operation.
     * @param node The node state.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_nodeUp(NodeDynamicInfo node, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_nodeUp(node, __ctx, true, __cb);
    }

    /**
     * The <tt>nodeUp</tt> operation is called to notify an observer that a node
     * came up.
     * 
     * @param __cb The callback object for the operation.
     * @param node The node state.
     * 
     **/
    public Ice.AsyncResult begin_nodeUp(NodeDynamicInfo node, Callback_NodeObserver_nodeUp __cb)
    {
        return begin_nodeUp(node, null, false, __cb);
    }

    /**
     * The <tt>nodeUp</tt> operation is called to notify an observer that a node
     * came up.
     * 
     * @param __cb The callback object for the operation.
     * @param node The node state.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_nodeUp(NodeDynamicInfo node, java.util.Map<String, String> __ctx, Callback_NodeObserver_nodeUp __cb)
    {
        return begin_nodeUp(node, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_nodeUp(NodeDynamicInfo node, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __nodeUp_name, __cb);
        try
        {
            __result.__prepare(__nodeUp_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__os();
            node.__write(__os);
            __os.endWriteEncaps();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_nodeUp(Ice.AsyncResult __result)
    {
        __end(__result, __nodeUp_name);
    }

    /**
     * The <tt>nodeUp</tt> operation is called to notify an observer that a node
     * came up.
     * 
     * @param __cb The callback object for the operation.
     * @param node The node state.
     * 
     **/
    public boolean
    nodeUp_async(AMI_NodeObserver_nodeUp __cb, NodeDynamicInfo node)
    {
        Ice.AsyncResult __r = begin_nodeUp(node, null, false, __cb);
        return __r.sentSynchronously();
    }

    /**
     * The <tt>nodeUp</tt> operation is called to notify an observer that a node
     * came up.
     * 
     * @param __cb The callback object for the operation.
     * @param node The node state.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean
    nodeUp_async(AMI_NodeObserver_nodeUp __cb, NodeDynamicInfo node, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r = begin_nodeUp(node, __ctx, true, __cb);
        return __r.sentSynchronously();
    }

    /**
     * The <tt>updateAdapter</tt> operation is called to notify an observer that
     * the state of an adapter changed.
     * 
     * @param node The node hosting the adapter.
     * 
     * @param updatedInfo The new adapter state.
     * 
     **/
    public void
    updateAdapter(String node, AdapterDynamicInfo updatedInfo)
    {
        updateAdapter(node, updatedInfo, null, false);
    }

    /**
     * The <tt>updateAdapter</tt> operation is called to notify an observer that
     * the state of an adapter changed.
     * 
     * @param node The node hosting the adapter.
     * 
     * @param updatedInfo The new adapter state.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public void
    updateAdapter(String node, AdapterDynamicInfo updatedInfo, java.util.Map<String, String> __ctx)
    {
        updateAdapter(node, updatedInfo, __ctx, true);
    }

    private void
    updateAdapter(String node, AdapterDynamicInfo updatedInfo, java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        int __cnt = 0;
        while(true)
        {
            Ice._ObjectDel __delBase = null;
            try
            {
                __delBase = __getDelegate(false);
                _NodeObserverDel __del = (_NodeObserverDel)__delBase;
                __del.updateAdapter(node, updatedInfo, __ctx);
                return;
            }
            catch(IceInternal.LocalExceptionWrapper __ex)
            {
                __handleExceptionWrapper(__delBase, __ex);
            }
            catch(Ice.LocalException __ex)
            {
                __cnt = __handleException(__delBase, __ex, null, __cnt);
            }
        }
    }

    private static final String __updateAdapter_name = "updateAdapter";

    /**
     * The <tt>updateAdapter</tt> operation is called to notify an observer that
     * the state of an adapter changed.
     * 
     * @param __cb The callback object for the operation.
     * @param node The node hosting the adapter.
     * 
     * @param updatedInfo The new adapter state.
     * 
     **/
    public Ice.AsyncResult begin_updateAdapter(String node, AdapterDynamicInfo updatedInfo)
    {
        return begin_updateAdapter(node, updatedInfo, null, false, null);
    }

    /**
     * The <tt>updateAdapter</tt> operation is called to notify an observer that
     * the state of an adapter changed.
     * 
     * @param __cb The callback object for the operation.
     * @param node The node hosting the adapter.
     * 
     * @param updatedInfo The new adapter state.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_updateAdapter(String node, AdapterDynamicInfo updatedInfo, java.util.Map<String, String> __ctx)
    {
        return begin_updateAdapter(node, updatedInfo, __ctx, true, null);
    }

    /**
     * The <tt>updateAdapter</tt> operation is called to notify an observer that
     * the state of an adapter changed.
     * 
     * @param __cb The callback object for the operation.
     * @param node The node hosting the adapter.
     * 
     * @param updatedInfo The new adapter state.
     * 
     **/
    public Ice.AsyncResult begin_updateAdapter(String node, AdapterDynamicInfo updatedInfo, Ice.Callback __cb)
    {
        return begin_updateAdapter(node, updatedInfo, null, false, __cb);
    }

    /**
     * The <tt>updateAdapter</tt> operation is called to notify an observer that
     * the state of an adapter changed.
     * 
     * @param __cb The callback object for the operation.
     * @param node The node hosting the adapter.
     * 
     * @param updatedInfo The new adapter state.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_updateAdapter(String node, AdapterDynamicInfo updatedInfo, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_updateAdapter(node, updatedInfo, __ctx, true, __cb);
    }

    /**
     * The <tt>updateAdapter</tt> operation is called to notify an observer that
     * the state of an adapter changed.
     * 
     * @param __cb The callback object for the operation.
     * @param node The node hosting the adapter.
     * 
     * @param updatedInfo The new adapter state.
     * 
     **/
    public Ice.AsyncResult begin_updateAdapter(String node, AdapterDynamicInfo updatedInfo, Callback_NodeObserver_updateAdapter __cb)
    {
        return begin_updateAdapter(node, updatedInfo, null, false, __cb);
    }

    /**
     * The <tt>updateAdapter</tt> operation is called to notify an observer that
     * the state of an adapter changed.
     * 
     * @param __cb The callback object for the operation.
     * @param node The node hosting the adapter.
     * 
     * @param updatedInfo The new adapter state.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_updateAdapter(String node, AdapterDynamicInfo updatedInfo, java.util.Map<String, String> __ctx, Callback_NodeObserver_updateAdapter __cb)
    {
        return begin_updateAdapter(node, updatedInfo, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_updateAdapter(String node, AdapterDynamicInfo updatedInfo, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __updateAdapter_name, __cb);
        try
        {
            __result.__prepare(__updateAdapter_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__os();
            __os.writeString(node);
            updatedInfo.__write(__os);
            __os.endWriteEncaps();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_updateAdapter(Ice.AsyncResult __result)
    {
        __end(__result, __updateAdapter_name);
    }

    /**
     * The <tt>updateAdapter</tt> operation is called to notify an observer that
     * the state of an adapter changed.
     * 
     * @param __cb The callback object for the operation.
     * @param node The node hosting the adapter.
     * 
     * @param updatedInfo The new adapter state.
     * 
     **/
    public boolean
    updateAdapter_async(AMI_NodeObserver_updateAdapter __cb, String node, AdapterDynamicInfo updatedInfo)
    {
        Ice.AsyncResult __r = begin_updateAdapter(node, updatedInfo, null, false, __cb);
        return __r.sentSynchronously();
    }

    /**
     * The <tt>updateAdapter</tt> operation is called to notify an observer that
     * the state of an adapter changed.
     * 
     * @param __cb The callback object for the operation.
     * @param node The node hosting the adapter.
     * 
     * @param updatedInfo The new adapter state.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean
    updateAdapter_async(AMI_NodeObserver_updateAdapter __cb, String node, AdapterDynamicInfo updatedInfo, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r = begin_updateAdapter(node, updatedInfo, __ctx, true, __cb);
        return __r.sentSynchronously();
    }

    /**
     * The <tt>updateServer</tt> operation is called to notify an observer that
     * the state of a server changed.
     * 
     * @param node The node hosting the server.
     * 
     * @param updatedInfo The new server state.
     * 
     **/
    public void
    updateServer(String node, ServerDynamicInfo updatedInfo)
    {
        updateServer(node, updatedInfo, null, false);
    }

    /**
     * The <tt>updateServer</tt> operation is called to notify an observer that
     * the state of a server changed.
     * 
     * @param node The node hosting the server.
     * 
     * @param updatedInfo The new server state.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public void
    updateServer(String node, ServerDynamicInfo updatedInfo, java.util.Map<String, String> __ctx)
    {
        updateServer(node, updatedInfo, __ctx, true);
    }

    private void
    updateServer(String node, ServerDynamicInfo updatedInfo, java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        int __cnt = 0;
        while(true)
        {
            Ice._ObjectDel __delBase = null;
            try
            {
                __delBase = __getDelegate(false);
                _NodeObserverDel __del = (_NodeObserverDel)__delBase;
                __del.updateServer(node, updatedInfo, __ctx);
                return;
            }
            catch(IceInternal.LocalExceptionWrapper __ex)
            {
                __handleExceptionWrapper(__delBase, __ex);
            }
            catch(Ice.LocalException __ex)
            {
                __cnt = __handleException(__delBase, __ex, null, __cnt);
            }
        }
    }

    private static final String __updateServer_name = "updateServer";

    /**
     * The <tt>updateServer</tt> operation is called to notify an observer that
     * the state of a server changed.
     * 
     * @param __cb The callback object for the operation.
     * @param node The node hosting the server.
     * 
     * @param updatedInfo The new server state.
     * 
     **/
    public Ice.AsyncResult begin_updateServer(String node, ServerDynamicInfo updatedInfo)
    {
        return begin_updateServer(node, updatedInfo, null, false, null);
    }

    /**
     * The <tt>updateServer</tt> operation is called to notify an observer that
     * the state of a server changed.
     * 
     * @param __cb The callback object for the operation.
     * @param node The node hosting the server.
     * 
     * @param updatedInfo The new server state.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_updateServer(String node, ServerDynamicInfo updatedInfo, java.util.Map<String, String> __ctx)
    {
        return begin_updateServer(node, updatedInfo, __ctx, true, null);
    }

    /**
     * The <tt>updateServer</tt> operation is called to notify an observer that
     * the state of a server changed.
     * 
     * @param __cb The callback object for the operation.
     * @param node The node hosting the server.
     * 
     * @param updatedInfo The new server state.
     * 
     **/
    public Ice.AsyncResult begin_updateServer(String node, ServerDynamicInfo updatedInfo, Ice.Callback __cb)
    {
        return begin_updateServer(node, updatedInfo, null, false, __cb);
    }

    /**
     * The <tt>updateServer</tt> operation is called to notify an observer that
     * the state of a server changed.
     * 
     * @param __cb The callback object for the operation.
     * @param node The node hosting the server.
     * 
     * @param updatedInfo The new server state.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_updateServer(String node, ServerDynamicInfo updatedInfo, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_updateServer(node, updatedInfo, __ctx, true, __cb);
    }

    /**
     * The <tt>updateServer</tt> operation is called to notify an observer that
     * the state of a server changed.
     * 
     * @param __cb The callback object for the operation.
     * @param node The node hosting the server.
     * 
     * @param updatedInfo The new server state.
     * 
     **/
    public Ice.AsyncResult begin_updateServer(String node, ServerDynamicInfo updatedInfo, Callback_NodeObserver_updateServer __cb)
    {
        return begin_updateServer(node, updatedInfo, null, false, __cb);
    }

    /**
     * The <tt>updateServer</tt> operation is called to notify an observer that
     * the state of a server changed.
     * 
     * @param __cb The callback object for the operation.
     * @param node The node hosting the server.
     * 
     * @param updatedInfo The new server state.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_updateServer(String node, ServerDynamicInfo updatedInfo, java.util.Map<String, String> __ctx, Callback_NodeObserver_updateServer __cb)
    {
        return begin_updateServer(node, updatedInfo, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_updateServer(String node, ServerDynamicInfo updatedInfo, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __updateServer_name, __cb);
        try
        {
            __result.__prepare(__updateServer_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__os();
            __os.writeString(node);
            updatedInfo.__write(__os);
            __os.endWriteEncaps();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_updateServer(Ice.AsyncResult __result)
    {
        __end(__result, __updateServer_name);
    }

    /**
     * The <tt>updateServer</tt> operation is called to notify an observer that
     * the state of a server changed.
     * 
     * @param __cb The callback object for the operation.
     * @param node The node hosting the server.
     * 
     * @param updatedInfo The new server state.
     * 
     **/
    public boolean
    updateServer_async(AMI_NodeObserver_updateServer __cb, String node, ServerDynamicInfo updatedInfo)
    {
        Ice.AsyncResult __r = begin_updateServer(node, updatedInfo, null, false, __cb);
        return __r.sentSynchronously();
    }

    /**
     * The <tt>updateServer</tt> operation is called to notify an observer that
     * the state of a server changed.
     * 
     * @param __cb The callback object for the operation.
     * @param node The node hosting the server.
     * 
     * @param updatedInfo The new server state.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean
    updateServer_async(AMI_NodeObserver_updateServer __cb, String node, ServerDynamicInfo updatedInfo, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r = begin_updateServer(node, updatedInfo, __ctx, true, __cb);
        return __r.sentSynchronously();
    }

    public static NodeObserverPrx
    checkedCast(Ice.ObjectPrx __obj)
    {
        NodeObserverPrx __d = null;
        if(__obj != null)
        {
            try
            {
                __d = (NodeObserverPrx)__obj;
            }
            catch(ClassCastException ex)
            {
                if(__obj.ice_isA("::IceGrid::NodeObserver"))
                {
                    NodeObserverPrxHelper __h = new NodeObserverPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static NodeObserverPrx
    checkedCast(Ice.ObjectPrx __obj, java.util.Map<String, String> __ctx)
    {
        NodeObserverPrx __d = null;
        if(__obj != null)
        {
            try
            {
                __d = (NodeObserverPrx)__obj;
            }
            catch(ClassCastException ex)
            {
                if(__obj.ice_isA("::IceGrid::NodeObserver", __ctx))
                {
                    NodeObserverPrxHelper __h = new NodeObserverPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static NodeObserverPrx
    checkedCast(Ice.ObjectPrx __obj, String __facet)
    {
        NodeObserverPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA("::IceGrid::NodeObserver"))
                {
                    NodeObserverPrxHelper __h = new NodeObserverPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static NodeObserverPrx
    checkedCast(Ice.ObjectPrx __obj, String __facet, java.util.Map<String, String> __ctx)
    {
        NodeObserverPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA("::IceGrid::NodeObserver", __ctx))
                {
                    NodeObserverPrxHelper __h = new NodeObserverPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static NodeObserverPrx
    uncheckedCast(Ice.ObjectPrx __obj)
    {
        NodeObserverPrx __d = null;
        if(__obj != null)
        {
            try
            {
                __d = (NodeObserverPrx)__obj;
            }
            catch(ClassCastException ex)
            {
                NodeObserverPrxHelper __h = new NodeObserverPrxHelper();
                __h.__copyFrom(__obj);
                __d = __h;
            }
        }
        return __d;
    }

    public static NodeObserverPrx
    uncheckedCast(Ice.ObjectPrx __obj, String __facet)
    {
        NodeObserverPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            NodeObserverPrxHelper __h = new NodeObserverPrxHelper();
            __h.__copyFrom(__bb);
            __d = __h;
        }
        return __d;
    }

    protected Ice._ObjectDelM
    __createDelegateM()
    {
        return new _NodeObserverDelM();
    }

    protected Ice._ObjectDelD
    __createDelegateD()
    {
        return new _NodeObserverDelD();
    }

    public static void
    __write(IceInternal.BasicStream __os, NodeObserverPrx v)
    {
        __os.writeProxy(v);
    }

    public static NodeObserverPrx
    __read(IceInternal.BasicStream __is)
    {
        Ice.ObjectPrx proxy = __is.readProxy();
        if(proxy != null)
        {
            NodeObserverPrxHelper result = new NodeObserverPrxHelper();
            result.__copyFrom(proxy);
            return result;
        }
        return null;
    }
}
