// **********************************************************************
//
// Copyright (c) 2003-2010 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.4.0

package IceGrid;

// <auto-generated>
//
// Generated from file `Query.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>


/**
 * The IceGrid query interface. This interface is accessible to
 * Ice clients who wish to look up well-known objects.
 * 
 **/
public interface QueryPrx extends Ice.ObjectPrx
{
    /**
     * Find a well-known object by identity.
     * 
     * @param id The identity.
     * 
     * @return The proxy or null if no such object has been found.
     * 
     **/
    public Ice.ObjectPrx findObjectById(Ice.Identity id);

    /**
     * Find a well-known object by identity.
     * 
     * @param id The identity.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The proxy or null if no such object has been found.
     * 
     **/
    public Ice.ObjectPrx findObjectById(Ice.Identity id, java.util.Map<String, String> __ctx);

    /**
     * Find a well-known object by identity.
     * 
     * @param id The identity.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findObjectById(Ice.Identity id);

    /**
     * Find a well-known object by identity.
     * 
     * @param id The identity.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findObjectById(Ice.Identity id, java.util.Map<String, String> __ctx);

    /**
     * Find a well-known object by identity.
     * 
     * @param id The identity.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findObjectById(Ice.Identity id, Ice.Callback __cb);

    /**
     * Find a well-known object by identity.
     * 
     * @param id The identity.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findObjectById(Ice.Identity id, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Find a well-known object by identity.
     * 
     * @param id The identity.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findObjectById(Ice.Identity id, Callback_Query_findObjectById __cb);

    /**
     * Find a well-known object by identity.
     * 
     * @param id The identity.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findObjectById(Ice.Identity id, java.util.Map<String, String> __ctx, Callback_Query_findObjectById __cb);

    /**
     * Find a well-known object by identity.
     * 
     * @param __result The asynchronous result object.
     * @return The proxy or null if no such object has been found.
     * 
     **/
    public Ice.ObjectPrx end_findObjectById(Ice.AsyncResult __result);

    /**
     * Find a well-known object by identity.
     * 
     * @param __cb The callback object for the operation.
     * @param id The identity.
     * 
     **/
    public boolean findObjectById_async(AMI_Query_findObjectById __cb, Ice.Identity id);

    /**
     * Find a well-known object by identity.
     * 
     * @param __cb The callback object for the operation.
     * @param id The identity.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean findObjectById_async(AMI_Query_findObjectById __cb, Ice.Identity id, java.util.Map<String, String> __ctx);

    /**
     * Find a well-known object by type. If there are several objects
     * registered for the given type, the object is randomly
     * selected.
     * 
     * @param type The object type.
     * 
     * @return The proxy or null, if no such object has been found.
     * 
     **/
    public Ice.ObjectPrx findObjectByType(String type);

    /**
     * Find a well-known object by type. If there are several objects
     * registered for the given type, the object is randomly
     * selected.
     * 
     * @param type The object type.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The proxy or null, if no such object has been found.
     * 
     **/
    public Ice.ObjectPrx findObjectByType(String type, java.util.Map<String, String> __ctx);

    /**
     * Find a well-known object by type. If there are several objects
     * registered for the given type, the object is randomly
     * selected.
     * 
     * @param type The object type.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findObjectByType(String type);

    /**
     * Find a well-known object by type. If there are several objects
     * registered for the given type, the object is randomly
     * selected.
     * 
     * @param type The object type.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findObjectByType(String type, java.util.Map<String, String> __ctx);

    /**
     * Find a well-known object by type. If there are several objects
     * registered for the given type, the object is randomly
     * selected.
     * 
     * @param type The object type.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findObjectByType(String type, Ice.Callback __cb);

    /**
     * Find a well-known object by type. If there are several objects
     * registered for the given type, the object is randomly
     * selected.
     * 
     * @param type The object type.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findObjectByType(String type, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Find a well-known object by type. If there are several objects
     * registered for the given type, the object is randomly
     * selected.
     * 
     * @param type The object type.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findObjectByType(String type, Callback_Query_findObjectByType __cb);

    /**
     * Find a well-known object by type. If there are several objects
     * registered for the given type, the object is randomly
     * selected.
     * 
     * @param type The object type.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findObjectByType(String type, java.util.Map<String, String> __ctx, Callback_Query_findObjectByType __cb);

    /**
     * Find a well-known object by type. If there are several objects
     * registered for the given type, the object is randomly
     * selected.
     * 
     * @param __result The asynchronous result object.
     * @return The proxy or null, if no such object has been found.
     * 
     **/
    public Ice.ObjectPrx end_findObjectByType(Ice.AsyncResult __result);

    /**
     * Find a well-known object by type. If there are several objects
     * registered for the given type, the object is randomly
     * selected.
     * 
     * @param __cb The callback object for the operation.
     * @param type The object type.
     * 
     **/
    public boolean findObjectByType_async(AMI_Query_findObjectByType __cb, String type);

    /**
     * Find a well-known object by type. If there are several objects
     * registered for the given type, the object is randomly
     * selected.
     * 
     * @param __cb The callback object for the operation.
     * @param type The object type.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean findObjectByType_async(AMI_Query_findObjectByType __cb, String type, java.util.Map<String, String> __ctx);

    /**
     * Find a well-known object by type on the least-loaded node. If
     * the registry does not know which node hosts the object
     * (for example, because the object was registered with a direct proxy), the
     * registry assumes the object is hosted on a node that has a load
     * average of 1.0.
     * 
     * @param type The object type.
     * 
     * @param sample The sampling interval.
     * 
     * @return The proxy or null, if no such object has been found.
     * 
     **/
    public Ice.ObjectPrx findObjectByTypeOnLeastLoadedNode(String type, LoadSample sample);

    /**
     * Find a well-known object by type on the least-loaded node. If
     * the registry does not know which node hosts the object
     * (for example, because the object was registered with a direct proxy), the
     * registry assumes the object is hosted on a node that has a load
     * average of 1.0.
     * 
     * @param type The object type.
     * 
     * @param sample The sampling interval.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The proxy or null, if no such object has been found.
     * 
     **/
    public Ice.ObjectPrx findObjectByTypeOnLeastLoadedNode(String type, LoadSample sample, java.util.Map<String, String> __ctx);

    /**
     * Find a well-known object by type on the least-loaded node. If
     * the registry does not know which node hosts the object
     * (for example, because the object was registered with a direct proxy), the
     * registry assumes the object is hosted on a node that has a load
     * average of 1.0.
     * 
     * @param type The object type.
     * 
     * @param sample The sampling interval.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findObjectByTypeOnLeastLoadedNode(String type, LoadSample sample);

    /**
     * Find a well-known object by type on the least-loaded node. If
     * the registry does not know which node hosts the object
     * (for example, because the object was registered with a direct proxy), the
     * registry assumes the object is hosted on a node that has a load
     * average of 1.0.
     * 
     * @param type The object type.
     * 
     * @param sample The sampling interval.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findObjectByTypeOnLeastLoadedNode(String type, LoadSample sample, java.util.Map<String, String> __ctx);

    /**
     * Find a well-known object by type on the least-loaded node. If
     * the registry does not know which node hosts the object
     * (for example, because the object was registered with a direct proxy), the
     * registry assumes the object is hosted on a node that has a load
     * average of 1.0.
     * 
     * @param type The object type.
     * 
     * @param sample The sampling interval.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findObjectByTypeOnLeastLoadedNode(String type, LoadSample sample, Ice.Callback __cb);

    /**
     * Find a well-known object by type on the least-loaded node. If
     * the registry does not know which node hosts the object
     * (for example, because the object was registered with a direct proxy), the
     * registry assumes the object is hosted on a node that has a load
     * average of 1.0.
     * 
     * @param type The object type.
     * 
     * @param sample The sampling interval.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findObjectByTypeOnLeastLoadedNode(String type, LoadSample sample, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Find a well-known object by type on the least-loaded node. If
     * the registry does not know which node hosts the object
     * (for example, because the object was registered with a direct proxy), the
     * registry assumes the object is hosted on a node that has a load
     * average of 1.0.
     * 
     * @param type The object type.
     * 
     * @param sample The sampling interval.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findObjectByTypeOnLeastLoadedNode(String type, LoadSample sample, Callback_Query_findObjectByTypeOnLeastLoadedNode __cb);

    /**
     * Find a well-known object by type on the least-loaded node. If
     * the registry does not know which node hosts the object
     * (for example, because the object was registered with a direct proxy), the
     * registry assumes the object is hosted on a node that has a load
     * average of 1.0.
     * 
     * @param type The object type.
     * 
     * @param sample The sampling interval.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findObjectByTypeOnLeastLoadedNode(String type, LoadSample sample, java.util.Map<String, String> __ctx, Callback_Query_findObjectByTypeOnLeastLoadedNode __cb);

    /**
     * Find a well-known object by type on the least-loaded node. If
     * the registry does not know which node hosts the object
     * (for example, because the object was registered with a direct proxy), the
     * registry assumes the object is hosted on a node that has a load
     * average of 1.0.
     * 
     * @param __result The asynchronous result object.
     * @return The proxy or null, if no such object has been found.
     * 
     **/
    public Ice.ObjectPrx end_findObjectByTypeOnLeastLoadedNode(Ice.AsyncResult __result);

    /**
     * Find a well-known object by type on the least-loaded node. If
     * the registry does not know which node hosts the object
     * (for example, because the object was registered with a direct proxy), the
     * registry assumes the object is hosted on a node that has a load
     * average of 1.0.
     * 
     * @param __cb The callback object for the operation.
     * @param type The object type.
     * 
     * @param sample The sampling interval.
     * 
     **/
    public boolean findObjectByTypeOnLeastLoadedNode_async(AMI_Query_findObjectByTypeOnLeastLoadedNode __cb, String type, LoadSample sample);

    /**
     * Find a well-known object by type on the least-loaded node. If
     * the registry does not know which node hosts the object
     * (for example, because the object was registered with a direct proxy), the
     * registry assumes the object is hosted on a node that has a load
     * average of 1.0.
     * 
     * @param __cb The callback object for the operation.
     * @param type The object type.
     * 
     * @param sample The sampling interval.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean findObjectByTypeOnLeastLoadedNode_async(AMI_Query_findObjectByTypeOnLeastLoadedNode __cb, String type, LoadSample sample, java.util.Map<String, String> __ctx);

    /**
     * Find all the well-known objects with the given type.
     * 
     * @param type The object type.
     * 
     * @return The proxies or an empty sequence, if no such objects
     * have been found.
     * 
     **/
    public Ice.ObjectPrx[] findAllObjectsByType(String type);

    /**
     * Find all the well-known objects with the given type.
     * 
     * @param type The object type.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The proxies or an empty sequence, if no such objects
     * have been found.
     * 
     **/
    public Ice.ObjectPrx[] findAllObjectsByType(String type, java.util.Map<String, String> __ctx);

    /**
     * Find all the well-known objects with the given type.
     * 
     * @param type The object type.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findAllObjectsByType(String type);

    /**
     * Find all the well-known objects with the given type.
     * 
     * @param type The object type.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findAllObjectsByType(String type, java.util.Map<String, String> __ctx);

    /**
     * Find all the well-known objects with the given type.
     * 
     * @param type The object type.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findAllObjectsByType(String type, Ice.Callback __cb);

    /**
     * Find all the well-known objects with the given type.
     * 
     * @param type The object type.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findAllObjectsByType(String type, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Find all the well-known objects with the given type.
     * 
     * @param type The object type.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findAllObjectsByType(String type, Callback_Query_findAllObjectsByType __cb);

    /**
     * Find all the well-known objects with the given type.
     * 
     * @param type The object type.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findAllObjectsByType(String type, java.util.Map<String, String> __ctx, Callback_Query_findAllObjectsByType __cb);

    /**
     * Find all the well-known objects with the given type.
     * 
     * @param __result The asynchronous result object.
     * @return The proxies or an empty sequence, if no such objects
     * have been found.
     * 
     **/
    public Ice.ObjectPrx[] end_findAllObjectsByType(Ice.AsyncResult __result);

    /**
     * Find all the well-known objects with the given type.
     * 
     * @param __cb The callback object for the operation.
     * @param type The object type.
     * 
     **/
    public boolean findAllObjectsByType_async(AMI_Query_findAllObjectsByType __cb, String type);

    /**
     * Find all the well-known objects with the given type.
     * 
     * @param __cb The callback object for the operation.
     * @param type The object type.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean findAllObjectsByType_async(AMI_Query_findAllObjectsByType __cb, String type, java.util.Map<String, String> __ctx);

    /**
     * Find all the object replicas associated with the given
     * proxy. If the given proxy is not an indirect proxy from a
     * replica group, an empty sequence is returned.
     * 
     * @param proxy The object proxy.
     * 
     * @return The proxies of each object replica or an empty sequence,
     * if the given proxy is not from a replica group.
     * 
     **/
    public Ice.ObjectPrx[] findAllReplicas(Ice.ObjectPrx proxy);

    /**
     * Find all the object replicas associated with the given
     * proxy. If the given proxy is not an indirect proxy from a
     * replica group, an empty sequence is returned.
     * 
     * @param proxy The object proxy.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The proxies of each object replica or an empty sequence,
     * if the given proxy is not from a replica group.
     * 
     **/
    public Ice.ObjectPrx[] findAllReplicas(Ice.ObjectPrx proxy, java.util.Map<String, String> __ctx);

    /**
     * Find all the object replicas associated with the given
     * proxy. If the given proxy is not an indirect proxy from a
     * replica group, an empty sequence is returned.
     * 
     * @param proxy The object proxy.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findAllReplicas(Ice.ObjectPrx proxy);

    /**
     * Find all the object replicas associated with the given
     * proxy. If the given proxy is not an indirect proxy from a
     * replica group, an empty sequence is returned.
     * 
     * @param proxy The object proxy.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findAllReplicas(Ice.ObjectPrx proxy, java.util.Map<String, String> __ctx);

    /**
     * Find all the object replicas associated with the given
     * proxy. If the given proxy is not an indirect proxy from a
     * replica group, an empty sequence is returned.
     * 
     * @param proxy The object proxy.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findAllReplicas(Ice.ObjectPrx proxy, Ice.Callback __cb);

    /**
     * Find all the object replicas associated with the given
     * proxy. If the given proxy is not an indirect proxy from a
     * replica group, an empty sequence is returned.
     * 
     * @param proxy The object proxy.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findAllReplicas(Ice.ObjectPrx proxy, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Find all the object replicas associated with the given
     * proxy. If the given proxy is not an indirect proxy from a
     * replica group, an empty sequence is returned.
     * 
     * @param proxy The object proxy.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findAllReplicas(Ice.ObjectPrx proxy, Callback_Query_findAllReplicas __cb);

    /**
     * Find all the object replicas associated with the given
     * proxy. If the given proxy is not an indirect proxy from a
     * replica group, an empty sequence is returned.
     * 
     * @param proxy The object proxy.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findAllReplicas(Ice.ObjectPrx proxy, java.util.Map<String, String> __ctx, Callback_Query_findAllReplicas __cb);

    /**
     * Find all the object replicas associated with the given
     * proxy. If the given proxy is not an indirect proxy from a
     * replica group, an empty sequence is returned.
     * 
     * @param __result The asynchronous result object.
     * @return The proxies of each object replica or an empty sequence,
     * if the given proxy is not from a replica group.
     * 
     **/
    public Ice.ObjectPrx[] end_findAllReplicas(Ice.AsyncResult __result);

    /**
     * Find all the object replicas associated with the given
     * proxy. If the given proxy is not an indirect proxy from a
     * replica group, an empty sequence is returned.
     * 
     * @param __cb The callback object for the operation.
     * @param proxy The object proxy.
     * 
     **/
    public boolean findAllReplicas_async(AMI_Query_findAllReplicas __cb, Ice.ObjectPrx proxy);

    /**
     * Find all the object replicas associated with the given
     * proxy. If the given proxy is not an indirect proxy from a
     * replica group, an empty sequence is returned.
     * 
     * @param __cb The callback object for the operation.
     * @param proxy The object proxy.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean findAllReplicas_async(AMI_Query_findAllReplicas __cb, Ice.ObjectPrx proxy, java.util.Map<String, String> __ctx);
}
