// **********************************************************************
//
// Copyright (c) 2003-2010 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.4.0

package IceGrid;

// <auto-generated>
//
// Generated from file `Observer.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>


/**
 * This interface allows applications to monitor the state of object
 * adapters that are registered with IceGrid.
 * 
 **/
public abstract class _AdapterObserverDisp extends Ice.ObjectImpl implements AdapterObserver
{
    protected void
    ice_copyStateFrom(Ice.Object __obj)
        throws java.lang.CloneNotSupportedException
    {
        throw new java.lang.CloneNotSupportedException();
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::IceGrid::AdapterObserver"
    };

    public boolean
    ice_isA(String s)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public boolean
    ice_isA(String s, Ice.Current __current)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public String[]
    ice_ids()
    {
        return __ids;
    }

    public String[]
    ice_ids(Ice.Current __current)
    {
        return __ids;
    }

    public String
    ice_id()
    {
        return __ids[1];
    }

    public String
    ice_id(Ice.Current __current)
    {
        return __ids[1];
    }

    public static String
    ice_staticId()
    {
        return __ids[1];
    }

    /**
     * The <tt>adapterAdded</tt> operation is called to notify an observer when
     * a dynamically-registered adapter was added.
     * 
     * @param info The details of the new adapter.
     **/
    public final void
    adapterAdded(AdapterInfo info)
    {
        adapterAdded(info, null);
    }

    /**
     * <tt>adapterInit</tt> is called after registration of
     * an observer to indicate the state of the registry.
     * 
     * @param adpts The adapters that were dynamically registered
     * with the registry (not through the deployment mechanism).
     * 
     **/
    public final void
    adapterInit(AdapterInfo[] adpts)
    {
        adapterInit(adpts, null);
    }

    /**
     * The adapterRemoved operation is called to notify an observer when
     * a dynamically-registered adapter was removed.
     * 
     * @param id The ID of the removed adapter.
     * 
     **/
    public final void
    adapterRemoved(String id)
    {
        adapterRemoved(id, null);
    }

    /**
     * The adapterUpdated operation is called to notify an observer when
     * a dynamically-registered adapter was updated.
     * 
     * @param info The details of the updated adapter.
     * 
     **/
    public final void
    adapterUpdated(AdapterInfo info)
    {
        adapterUpdated(info, null);
    }

    public static Ice.DispatchStatus
    ___adapterInit(AdapterObserver __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.is();
        __is.startReadEncaps();
        AdapterInfo[] adpts;
        adpts = AdapterInfoSeqHelper.read(__is);
        __is.endReadEncaps();
        __obj.adapterInit(adpts, __current);
        return Ice.DispatchStatus.DispatchOK;
    }

    public static Ice.DispatchStatus
    ___adapterAdded(AdapterObserver __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.is();
        __is.startReadEncaps();
        AdapterInfo info;
        info = new AdapterInfo();
        info.__read(__is);
        __is.endReadEncaps();
        __obj.adapterAdded(info, __current);
        return Ice.DispatchStatus.DispatchOK;
    }

    public static Ice.DispatchStatus
    ___adapterUpdated(AdapterObserver __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.is();
        __is.startReadEncaps();
        AdapterInfo info;
        info = new AdapterInfo();
        info.__read(__is);
        __is.endReadEncaps();
        __obj.adapterUpdated(info, __current);
        return Ice.DispatchStatus.DispatchOK;
    }

    public static Ice.DispatchStatus
    ___adapterRemoved(AdapterObserver __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.is();
        __is.startReadEncaps();
        String id;
        id = __is.readString();
        __is.endReadEncaps();
        __obj.adapterRemoved(id, __current);
        return Ice.DispatchStatus.DispatchOK;
    }

    private final static String[] __all =
    {
        "adapterAdded",
        "adapterInit",
        "adapterRemoved",
        "adapterUpdated",
        "ice_id",
        "ice_ids",
        "ice_isA",
        "ice_ping"
    };

    public Ice.DispatchStatus
    __dispatch(IceInternal.Incoming in, Ice.Current __current)
    {
        int pos = java.util.Arrays.binarySearch(__all, __current.operation);
        if(pos < 0)
        {
            throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
        }

        switch(pos)
        {
            case 0:
            {
                return ___adapterAdded(this, in, __current);
            }
            case 1:
            {
                return ___adapterInit(this, in, __current);
            }
            case 2:
            {
                return ___adapterRemoved(this, in, __current);
            }
            case 3:
            {
                return ___adapterUpdated(this, in, __current);
            }
            case 4:
            {
                return ___ice_id(this, in, __current);
            }
            case 5:
            {
                return ___ice_ids(this, in, __current);
            }
            case 6:
            {
                return ___ice_isA(this, in, __current);
            }
            case 7:
            {
                return ___ice_ping(this, in, __current);
            }
        }

        assert(false);
        throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
    }

    public void
    __write(IceInternal.BasicStream __os)
    {
        __os.writeTypeId(ice_staticId());
        __os.startWriteSlice();
        __os.endWriteSlice();
        super.__write(__os);
    }

    public void
    __read(IceInternal.BasicStream __is, boolean __rid)
    {
        if(__rid)
        {
            __is.readTypeId();
        }
        __is.startReadSlice();
        __is.endReadSlice();
        super.__read(__is, true);
    }

    public void
    __write(Ice.OutputStream __outS)
    {
        Ice.MarshalException ex = new Ice.MarshalException();
        ex.reason = "type IceGrid::AdapterObserver was not generated with stream support";
        throw ex;
    }

    public void
    __read(Ice.InputStream __inS, boolean __rid)
    {
        Ice.MarshalException ex = new Ice.MarshalException();
        ex.reason = "type IceGrid::AdapterObserver was not generated with stream support";
        throw ex;
    }
}
